unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
  TAGraph, TASeries, TASources, TACustomSource;

type

  { TForm1 }

  TForm1 = class(TForm)
    Chart1: TChart;
    Chart1BarSeries1: TBarSeries;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Label1: TLabel;
    Panel1: TPanel;
    ScrollBar1: TScrollBar;
    UserDefinedChartSource1: TUserDefinedChartSource;
    procedure CheckBox1Change(Sender: TObject);
    procedure CheckBox2Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure GetAxisDataItem(
      ASource: TUserDefinedChartSource; AIndex: Integer;
      var AItem: TChartDataItem);
    procedure ScrollBar1Change(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  TAChartUtils;

{ TForm1 }

procedure TForm1.CheckBox1Change(Sender: TObject);
begin
  if Checkbox1.Checked then
    Chart1BarSeries1.Depth := 20
  else
    Chart1BarSeries1.Depth := 0;
end;

procedure TForm1.CheckBox2Change(Sender: TObject);
begin
  if Checkbox2.Checked then
    Chart1BarSeries1.Marks.Style := smsValue
  else
    Chart1BarSeries1.Marks.Style := smsNone;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Chart1BarSeries1.Add(100, 'Frühling', clGreen);
  Chart1BarSeries1.Add(150, 'Sommer', clYellow);
  Chart1BarSeries1.Add(105, 'Herbst', clMaroon);
  Chart1Barseries1.Add(80, 'Winter', clWhite);

  Chart1Barseries1.Marks.Style := smsValue;

  Chart1Barseries1.AxisIndexX := 0;
  Chart1BarSeries1.AxisIndexY := 1;

  Chart1.LeftAxis.Marks.Source := TUserDefinedChartSource.Create(self);
  with TUserDefinedChartSource(Chart1.LeftAxis.Marks.Source) do
  begin
    PointsNumber := Chart1BarSeries1.Count;
    OnGetChartDataItem := @GetAxisDataItem;
  end;
  Chart1.LeftAxis.Marks.Style := smsLabel;

  ScrollBar1.Position := Chart1BarSeries1.BarWidthPercent;
end;

procedure TForm1.GetAxisDataItem(
  ASource: TUserDefinedChartSource; AIndex: Integer; var AItem: TChartDataItem);
begin
  AItem.X := Chart1BarSeries1.YValue[AIndex];
  AItem.Y := Chart1BarSeries1.XValue[AIndex];
  AItem.Text := Chart1BarSeries1.Source[AIndex]^.Text;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  Chart1BarSeries1.BarWidthPercent := Scrollbar1.Position;
end;


end.

